1000 :rem:-basic-top
1010  rem *** Multi Sprite Viewer
1020  rem *** pjwitte 2oo4
1030  :
1040  rem *** SMSQ/E 3.03+, ptrmen_cde (EZPtr)
1050  rem *** QLib_run, QMenu, own toolkit
1060  :
1070  rem *** v0.01 - Test version February 25th 2004
1080  rem *** v0.02 - February 26th 2004
1090  rem *** v0.03 - February 27th 2004
1100  rem *** v0.04 - Esc from dir_select doesnt crash
1110  rem ***         Dir closed if no sprite; other
1120  rem *** v0.05 - Improved display logic
1130  rem *** v0.06 - Redsigned data structure: chop without re-loading
1140  rem ***         Fixed problem with occasional non-display of valid sprites
1150  :
1160  rem >>> v0.07 - bsjr; 18.03.14; fxd oversized, add quit prompt,
1170  rem >>>         more Disp info, chk invalid sprs, Tinfo,
1180  rem >>>         '.spr' for NFA, maximise fit, fxd m4 use,
1190  ::
1200 :rem:-begin-basic
1210  EXT_PROC 'WRESZ'
1220  EXT_FN 'MN_MSPRV','SP_NUL','SP_GD2','GET_SSPRA','GET_FSPRA'
1230  EXT_FN 'LIN2STR$','CFHOME$','CFNAME$','CFVER$','SPR_001','LOOKUP%'
1240  EXT_FN 'DMODE','WMAVER$'
1250  :
1260  REMark $$chan=6
1270  REMark $$heap=2048
1280  REMark $$stak=1280
1290  REMark $$asmb=dev8_Per_Mspv_msprv_bin,0,10
1300  REMark $$asmb=dev8_Per_My_S_Spr2Big_bin,0,10
1310  REMark $$asmb=dev8_Lib_R_Function_bin,0,314
1320  REMark $$asmb=dev8_Lib_R_Display_cde,0,10
1330  :
1340  rem *** Development setup under QD &SMSQ/E
1350  beta$= '0.07.09': datm$= '2014-10-06'
1360  cmpl%= 1:: test%= 0                         : rem >007; compile flag >007f; test
1370  if ver$ <>'HBA' then cmpl%= 2               : rem >007h; qdos, chk >H>
1380  home$= '': home%= (lookup%('HOME_DIR$') >0) : rem >007; chk =0/1
1390  REMark $$off
1400  if peek$(\\-4, 4) ='SBAS' then
1410    cmpl%= 0: test%= 1
1420    job_name 'Msprv'
1430    root$ = 'dev8_Per_My_'
1440    lrespr root$ &'Msp_msprv_bin'
1450    lrespr root$ &'S_Spr2Big_bin'   : rem >007; m4,8,32
1460    lrespr 'dev8_lib_R_display_cde' : rem >007h; dmode,wma
1470  end if
1480  REMark $$on
1490  :
1500  if cmpl%
1510    root$ = cfhome$ : rem >007; Qlib'd
1520    msprv$= cfname$
1530  end if
1540  :
1550  rem >>> chk mode & spr.adr
1560  smde%= dmode: sp_big= SPR_001            : rem >H>007h; spr.adr m4
1570  sel on smde%
1580    =16 to 33 : sp_big= sp_big +2032       : rem >007; gd2, spr.adr m32
1590      bigx%= 132: bigy%= 38                : rem >007g; s2big size m32
1600    =remainder : bigx%= 60: bigy%= 32      : rem >007g; s2big size m4
1610      if smde% >0 then mode 4: smde%= 0    : rem >007h; force m4
1620  end sel
1630  :
1640  rem *** Get config data
1650  if home% then home$= home_dir$(-1)
1660  apmv%= 0: k64= 65536                     : rem >007; flag 'APM' viewer
1670  if '%T%' instr(cmd$) then test%= 1       : rem >007f; force test
1680  if test% then testd$= 'ram2_MspvDir_txt' : rem >007g; set tmp file
1690  if GetCfg <0 then stop                   : rem >007; set row, col, apmv%, +RPER
1700  rem:: rows%= 3: cols%= 2                 : rem >T>007f; ignore _cfg
1710  :
1720  Mspv_Init: Refresh -1: Mspv_Main         : rem >007f; parm
1730  stop
1740  ::
1750 :rem:-init
1760  def proc Mspv_Init
1770  rem *** Init
1780   dim pr%(16)          : rem 'Pointer Record'
1790   avail%= 1: unav%= 17 : rem MSTAT contstants
1800   addr= 0: allspr= 0   : rem >T>007h; keep heap size
1810  :
1820   rem *** Constants
1830   wbdx% = 10: wbdy%= 40 : rem Extra window dimensions
1840   wmnx% = 400 -wbdx%    : rem Main AW (minimum) size
1850   wmny% = 200 -wbdy%
1860   smnx% = 30: smny%= 30 : rem Min sprite square size
1870   xbar% = 8 : yarw%= 12 : rem >007b/c; bar/arw
1880   lwszx%= wmnx%: lwszy%= wmny%
1890  :
1900   rem *** Variables
1910   Zap 1                            : rem >007h; flag all
1920   setsz= 0                         : rem Size constraint = off
1930   cszx%= smnx% +8: cszy%= smny% +4 : rem Min square size
1940   extn$= '_spr': extd$= '.spr'     : rem >007; as var >007e; nfa
1950  :
1960   rem *** Start
1970   if cmpl% then close #1                 : rem >007i; tmp error wndo
1980   mch= fopen(#mch,'con_'): ert mch       : rem >007i;
1990   flim #mch; wmxx%, wmxy%, x%, y%
2000   wmxx%= wmxx% -wbdx% -xbar% -(shad% *4) : rem >007c; bar outside AW
2010   wmxy%= wmxy% -wbdy% -yarw% -(shad% *4) : rem >007c; arws inside AW
2020  :
2030   rem >007b; read _cfg level 02 (0x0 =as below), dft 1x1 as level 01
2040   if cols% =0 or rows% =0 then
2050     cols%= 8: rows%= 5             : rem >007; +/- 170x140 dft for max
2060     if wmxx% <=1024 then cols%= 6: rows%= 4
2070     if wmxx% <= 800 then cols%= 5: rows%= 4
2080     if wmxx% <= 640 then cols%= 4: rows%= 3
2090     if wmxx% <= 512 then
2100       cols%= 3: rows%= 3           : rem >007; 512x480 Aur
2110       if wmxy% <=256 then rows%= 2 : rem >007; standaard QL
2120     end if
2130   end if
2140   CellMax : rem >007g; set max cell
2150  :
2160   pr%(10)= 1: pr%(11)= -1
2170  end def Mspv_Init
2180  :
2190 :rem:-main
2200  def proc Mspv_Main
2210  rem *** Program loop
2220  loc main, ak, lk, xp%, yp%, aw : lk= 0
2230   rep main
2240    ak= mcall(#wrkdf\ ak, 0): pval #wrkdf; pr%
2250    sel on ak
2260      =-2 : rem Resize
2270        if pr%(5) =1 then
2280          wresz wrkdf, xp%, yp% : rem >007c; +adr
2290         :
2300          if (wszx% -xp%) <wmnx% then xp%= wszx% -wmnx%
2310          wszx%= wszx% -xp%
2320          pr%(10)= pr%(10) +xp%: if pr%(10) <2 then pr%(10)= 2
2330          :
2340          if (wszy% -yp%) <wmny% then yp%= wszy% -wmny%
2350          wszy% =wszy% -yp%
2360          pr%(11)= pr%(11) +yp%: if pr%(11) <0 then pr%(11)= 0
2370          setsz= 1: lwszx%= wszx%: lwszy%= wszy% : rem Size constraint on
2380          Chop
2390        else
2400          setsz= 0: Chop
2410        end if
2420        Refresh 1
2430      =-4 : rem Quit (DO kills any Sprv jobs)
2440        main= item_select('MSPRV','QUIT, are you sure?','No','Yes',,,, 250 *k64)
2450        if main <>2 then next main
2460        if pr%(5) =2 or apmv% then DelJobs : rem >007h; +apmv
2470        if test% then delete testd$        : rem >007g;
2480        ret : rem >>> quit
2490      =-5 : rem Load
2500        if pr%(5) =2 then ldir$= ddir$
2510        dir$= dir_select$('Select directory',, 0, 40, -1, -1, ldir$)
2520        if len(dir$) >4 then
2530          ldir$= dir$: Mess 'Searching... '
2540          scnt= GetSprites
2550          if scnt <0 then
2560            Mess 'Error ' &scnt
2570          else
2580            if scnt =0 then Zap 1 : rem >007h; all
2590            Chop: Refresh 1
2600            Mess scnt &' sprites found'
2610          end if
2620        end if
2630      =-6 : rem Sprv
2640        if pr%(5) =2 then
2650          DelJobs
2660        else
2670          PickJobs
2680        end if
2690      =-7 : rem Pal
2700        if pr%(5) =2 then Tinfo 1: next main
2710        pal%= (pal% +1) mod 4
2720        sp_jobpal -1, pal%
2730        Refresh 0
2740        rdpt #wrkdf; 48, pr%(14), pr%(15)
2750      =-1088 : rem Wake Sprv Jobs, no LI only ^F2
2760        PickJobs
2770      =1 to 256 : rem AW, find top aw.item
2780        aw= mawnum (#wrkdf\ak, xp%, yp%) : rem >007c; chk scroll top
2790        if vrws% =1 then
2800          disp yp% *gszx% : rem >007g; just 1 row visible, upd info 1st item
2810        end if
2820      =k64 to 1e9 : rem Menu item
2830        awn= ak: if lk =ak then lk= 0: else ak= lk: lk= awn
2840        n%= (awn -1) /k64 -1
2850        if pr%(5) =2 and spid%(n%, 0) >=0 then
2860          rem >007e; only valid spid, 0/1/2, 3=2big
2870          if sprv% then
2880            if apmv%
2890              rem >007; do SprvAPM by addr >007f; restore org type 1/2
2900              if spid%(n%, 0) >0 then
2910                poke_w sprad(n%) +8, xyz%(n%, 2): poke_w sprad(n%) +10, xyz%(n%, 3)
2920              end if
2930              ex sprv$; 'Sprv@' &sprn$(n%) &'$' &hex$(sprad(n%),32) &'%' &pal%
2940            else
2950              if spid%(n%, 1) then
2960                ex sprv$; dir$ &sprn$(n%) &extd$ &' %' &pal% : rem >007e; '.spr'
2970              else
2980                ex sprv$; dir$ &sprn$(n%) &extn$ &' %' &pal% : rem >007e; '_spr'
2990              end if
3000            end if
3010          end if
3020        end if
3030        Disp n%
3040    end sel
3050   end rep main
3060  end def Mspv_Main
3070  ::
3080 :rem:-procs_
3090  def fn GetSprites
3100  loc cntl, i%, j%, dch, dln, szt, pos, fll, ft%, nl%
3110  loc xs%, ys%, vt%, vm%, cnt%, ext$, spm
3120  rem GLObal dev$, path$, spad ;>007; pth$ ->path$, ambiguous
3130  :
3140  rem First count then load all sprites in directory
3150   dev$= dir$(1 to 5)
3160   if len(dir$) >5 then
3170     path$= dir$(6 to)
3180   else
3190     path$= ''
3200   end if
3210  :
3220   rem *** Count sprites
3230   dch= fop_dir(dir$): if dch <0 then ret dch
3240   dln= flen(#dch): szt= 0: cnt%= 0: pos= -64
3250  :
3260   rep cntl
3270     pos= pos +64: if pos >=dln then exit cntl
3280     if cnt% >32764 then exit cntl
3290     lget #dch\pos +0, fll : rem >>> file length (+64)
3300    :
3310     rem Max sprite size depends on hardware and settings
3320     rem ... >007; see below cmxx/y
3330    :
3340     nl%= Rd_SprFile(dch, fll, extn$, extd$) : rem >007; as Fn >007d/e; +len, '.spr'
3350     if nl% =0 then next cntl
3360     cnt%= cnt% +1                           : rem >007e; neg if '.spr', ignore
3370     fll= fll -64 +(int(fll /2) <>(fll /2))  : rem Make Long even >007; shorter
3380     szt= szt +fll
3390   end rep cntl
3400  :
3410   if cnt% =0 then
3420     close #dch: ret 0
3430   else
3440     if cnt% >32764 then close #dch: ret -5 : rem >007; moved from rep loop 2, =unlikely
3450     CellMax : rem >007g; reset max cmxx/y
3460     if cnt% >1 then
3470       if cols% =1 then cmxx%= cmxx% -xbar%
3480       if rows% =1 then cmxy%= cmxy% -yarw%  : rem >007e; !assume scroll
3490     end if
3500   end if
3510  :
3520   rem Init structures (save xy org as these must be destroyed)
3530   dim sprn$(cnt%, 20), sprad(cnt%)  : rem >007; more name chrs
3540   dim spid%(cnt%, 1), xyz%(cnt%, 4) : rem >007; +spid >007e; +flg nfa, xyz
3550  :
3560   if addr >0 then Zap 0             : rem >007h; dump Sprv's, may rely on adr!
3570   addr= alchp(szt): allspr= szt     : rem >007h; keep heap size
3580   if addr <=0 then close #dch: ret -3
3590  :
3600   rem *** Load sprites
3610   spad= addr:  cnt%= -1: pos= -64
3620   smxx%= smnx%: smxy%= smny% : rem Reset max grid size
3630   rep cntl
3640     rem Filter out undesirables
3650     pos= pos +64: if pos >=dln then exit cntl
3660     lget #dch\pos +0, fll : rem >>> file length (len +64)
3670     rem Max sprite size check ..>007; see cmxx/y, spid
3680    :
3690     nl%= Rd_SprFile(dch, fll, extn$, extd$) : rem >007; as Fn >007d; +len >007e; '.spr'
3700     if nl% =0 then next cntl
3710    :
3720     rem Got a candidate
3730     cnt%= cnt% +1
3740     spid%(cnt%, 1)= (nl% <0): nl%= abs(nl%) : rem >007e; flag nfa =neg length
3750     sprad(cnt%)= spad: spid%(cnt%, 0)= 0    : rem >007e; flag valid for now
3760     lbytes dev$ &fnm$, spad
3770    :
3780     rem Find max sprite size >007; chk form
3790     vt%= peek(spad): vm%= peek(spad +1)
3800     sel on vt%
3810       =0 : if vm% <0 or vm% >37 then vt%= -1 : rem >007; chk valid spr
3820       =2 : if vm% <0 or vm% >64 then vt%= -1
3830       =1 : if vm% <0 or vm% >1  then vt%= -1
3840       =remainder : vt%= -1
3850     end sel
3860     sel on vt% =1,2 : if fll <(64 +32) then vt%= -1 : rem >007d; ? too small
3870    :
3880     if vt% <0 then
3890       spid%(cnt%, 0)= vt%                : rem >007; flag invalid >007e;
3900       for j% =0 to 3 : xyz%(cnt%, j%)= 0 : rem >007e; xyz(), init for Qlib
3910       xyz%(cnt%, 4)= vt%                 : rem >T>007h; for Tarray
3920     else
3930       if vt% >0 then spm= spad: else spm= get_sspra(peek(spad +1))
3940       spid%(cnt%, 0)= vt%                 : rem >007f; type 1/2
3950       xs%= peek_w(spm +4): ys%= peek_w(spm +6)
3960       if xs% +8 >cmxx% or ys% +4 >cmxy% then
3970         spid%(cnt%, 0)= 3                 : rem >007f; flag oversized =3
3980         if smxx% <bigx% then smxx%= bigx% : rem >007g; s2big_spr must fit!
3990         if smxy% <bigy% then smxy%= bigy%
4000       else
4010         if xs% >smxx% then smxx%= xs%
4020         if ys% >smxy% then smxy%= ys%
4030       end if   : rem >007e; only upd smxx/y% if spr fits
4040      :
4050       rem Ensure zero origin (except sys!)
4060       xyz%(cnt%, 0)= xs%: xyz%(cnt%, 1)= ys% : rem >007e; xyz() size/org/shad
4070       xyz%(cnt%, 2)= peek_w(spm +8)
4080       xyz%(cnt%, 3)= peek_w(spm +10)
4090       xyz%(cnt%, 4)= 4 *(vm% =0) +8 *(vm% =1) +vm% *(vm% >1)
4100       if vt% >0 then poke_l spad +8, 0
4110     end if
4120    :
4130     rem Subtract header length and make even
4140     fll= fll -64 +(int(fll /2) <>(fll /2)) : rem >007; shorter
4150     spad= spad +fll
4160    :
4170     rem Extract filename
4180     sprn$(cnt%)= fnm$(len(path$) +1 to nl% -4)
4190   end rep cntl
4200   rem:: pze= item_select('T','_GetSprites done','ok')
4210   close #dch: ret cnt% +1
4220  end def GetSprites
4230  ::
4240  def proc Chop
4250  rem *** Chop array
4260  rem Change: GLObal gszx/y%, cszx/y%
4270  rem Read: GLObal wmnx/y%, wmxx/y%, wszx/y%, scnt
4280  loc i%, c%, r%, xg%, yg%, ad, tad, max
4290   if scnt ==0 then ret : rem >>> no sprs!
4300  :
4310   rem *** Calculate square size
4320   cszx%= (smxx% +8) && -2 : rem >>> round down to even
4330   cszy%= (smxy% +4) && -2
4340  :
4350   rem *** Determine grid size
4360   if setsz then
4370     rem Fit data to window
4380     gszx%= int(wszx% /cszx%) : rem no. visible columns
4390     if gszx% =0 then gszx%= 1
4400   else
4410     rem Fit window to data
4420     gszx%= int(sqrt(scnt)) : rem Round down
4430     max= gszx% *cszx% +gszx% *2 +2
4440     if max >wmxx% then
4450       MaxCells gszx%, cszx%, wmxx% : rem >007e; adjust gszx%
4460     else
4470       if max <=wmnx% then
4480         gszx%= int(wmnx% /cszx%)
4490         if gszx% =0 then gszx%= 1
4500       end if
4510     end if
4520   end if
4530   Gridy : rem Calculate grid size y (gszy%)
4540  :
4550   rem *** Init and fill structures
4560   xg%= gszx% -1: yg%= gszy% -1
4570   dim sprs$(xg%, yg%, 12), stat%(xg%, yg%)
4580  :
4590   rem:: mwindow #mch, 1: wm_ink #mch; 536 : rem >T>007;
4600   for i% =0 to scnt -1
4610     c%= i% mod gszx%: r%= i% div gszx%
4620     rem:: ad= get_fspra(get_sspra(0)): tad= get_fspra(sprad(i%))
4630     rem:: print #mch; lin2str$(ad), lin2str$(tad): pause #mch; -1
4640     xg%= peek(sprad(i%)): yg%= peek(sprad(i%) +1)
4650     rem:: cls #mch: print #mch; xg%! yg%,: pause #mch; -1
4660     if smde% =0 and spid%(i%, 0) >=0 then
4670       rem Find alternatives for non-displayable sprites
4680       if xg% =2 then
4690         sprnw= sp_gd2
4700       else
4710         if yg% <>smde%
4720           sprnw= get_sspra(3) : rem Mode sprite
4730         else
4740           sprnw= sprad(i%)    : rem >007f; xg% =1, should be ok
4750         end if
4760       end if
4770     else
4780       sprnw= sprad(i%)
4790     end if
4800     rem >007; chk oversized, invalid
4810     if spid%(i%, 0) =3  then sprnw= sp_big       : rem >007; oops! too big
4820     if spid%(i%, 0) =-1 then sprnw= get_sspra(1) : rem >007; invalid! padlock
4830     sprs$(c%, r%)= '@' &lin2str$(sprnw)
4840     stat%(c%, r%)= avail%
4850   end for i%
4860  :
4870   rem *** Pad remainder with nul sprites
4880   for i% =scnt to gszx% *gszy% -1
4890     c%= i% mod gszx%: r%= i% div gszx%
4900     sprs$(c%, r%)= '@' &lin2str$(sp_nul)
4910     stat%(c%, r%)= unav%
4920   end for i%
4930   rem:: pze= item_select('T','_Chop done','ok')
4940   :: if test% and not cmpl% then Tarray 1 : rem >T>007;
4950  end def Chop
4960  ::
4970  def proc Refresh (new%)
4980  rem *** Refresh display using current data (if any)
4990  rem >007g; new -1= 1st time, 0= pal change, 1= wake/resize
5000  loc outlx%, outly%, i%, rw%, t$, tl$
5010   if new%
5020     if setsz then
5030       wszx%= lwszx%: wszy%= lwszy%
5040       vrws%= wszy% /(cszy% +2)              : rem >007e; +cell-border
5050     else
5060       rem "Best fit" given current grid arrangement
5070       wszx%= gszx% *cszx% +gszx% *2 +2         : rem >007c; +cell-border
5080       rw%= gszy%: MaxCells rw%, cszy%, wmxy%   : rem >007e; find max rows for wndo
5090       wszy%= rw% *cszy% +rw% *2 +2: vrws%= rw% : rem >007c; max visible rows
5100     end if
5110     rem:: if scnt then pze= item_select('T','_Refresh grid done','ok')
5120    :
5130     rem Keep window size within screen limits >007e; max chkd before
5140     if wszx% <wmnx% then wszx%= wmnx%
5150     if wszy% <wmny% then wszy%= wmny%
5160     rem:: if scnt then pze= item_select('T','_Refresh size done','ok')
5170   end if
5180  :
5190   rem Redraw window
5200   if new% >=0 then mclear #mch              : rem >007h; new%
5210   outlx%= wszx% +wbdx% +xbar%               : rem >007c; pre-calc
5220   outly%= wszy% +wbdy% +yarw%
5230   er%= mch: msbg= 535                       : rem >007h; wndo err, AW bg $217
5240  :
5250   msetup #er%; mn_msprv, pr%(10) -2, pr%(11), outlx%, outly%
5260   Ermess er%, 2                             : rem >007h; ? Mdraw OK
5270   wrkdf= mwdef(#er%): poke wrkdf +41, shad% : rem >007c; shad, org =3
5280   t$= mtext$(#wrkdf, 2, 1): tl%= len(t$)    : rem >007e; get title
5290   mdraw #wrkdf
5300   mwindow #wrkdf, 2!: cls #mch: wm_ink #mch; 518 : rem >007e; dmp ttl, set ttlfg
5310   cursor #mch; ((138 -tl% *6) div 2), 1     : rem >007e; centre, size =fixed!
5320   print #mch; t$                            : rem >007e; restore title
5330   lwszx%= wszx%: lwszy%= wszy%
5340   rem:: pause #mch; -1: mwindow #mch, 1: Tinfo 0
5350  :
5360   rem Redraw sprites >007e; cell-border already subtracted
5370   mawsetup #wrkdf; 1, sprs$, 0, 0, -2, cszx%, cszy%, 0, 0
5380   ErMess er%, 2                             : rem >007h; stop @ErM
5390   if pal% =opal% and awbg >0 then
5400     MawPaper wrkdf, awbg, msbg, new%
5410     mwindow #wrkdf, 1: wm_paper #mch; awbg: cls #mch : rem >007g; new bgrd
5420   end if
5430   mstat #wrkdf, 1, stat%: mawdraw #wrkdf\ 1
5440   mitem #wrkdf; -7, 0, '' &pal%
5450   if not new% and scnt then Mess scnt &' sprites found' : rem >007g; pal changed
5460  end def Refresh
5470  ::
5480  def fn GetCfg
5490  loc i%, c%, cch, tmp$, tch%                      : rem >007; local, home%/$
5500   ldir$= '': ddir$= '': sprv$= '': sprvn$= ''     : rem >007; init Globals
5510   cfg%= 1: cols%= 1: rows%= 1: shad%= -1: awbg= 0 : rem >007b/g; set dfts
5520   if cmpl% then
5530     open #1;'con'                                 : rem >007i; for GetCfg error mess
5540     cch= wmaver$(#1)                              : rem >007h; chk v2
5550     if cch <2 then ErMess -cch, 0: ret -1         : rem >007h; WM-2-old!
5560   end if
5570   cch= fop_in(root$ &'msprv_cfg')
5580   if cch <0 then
5590     if home% then cch= fop_in(home$ &'msprv_cfg')
5600   end if
5610   if cch <0 then ErMess cch, -1: ret cch          : rem >007h; not found!
5620  :
5630   for i% =1 to 4
5640     k$= inkey$(#cch; -1)
5650     if not k$ =='mspv'(i%) then ret -12
5660   end for i%
5670   k$= inkey$(#cch; -1) &inkey$(#cch; -1)
5680   if k$ <>'01' then
5690     if k$ <>'02' then ret -19
5700     cfg%= k$ : rem >007b; keep cfg level
5710   end if
5720  :
5730   get #cch\0: input #cch; tmp$         : rem Dummy
5740   input #cch; ddir$                    : rem Default dir
5750   if len(ddir$) <4: ddir$= datad$      : rem >007f; 0->4
5760   ldir$= ddir$                         : rem Floating directory base
5770   input #cch; sprv$                    : rem Sprite viewer (or other viewer)
5780   input #cch; sprvn$                   : rem Sprite viewer job name
5790   input #cch; tmp$                     : rem Default palette
5800   opal%= '0' &tmp$                     : rem >007c; dft zero if false
5810   pal%= opal% *(opal% >0 and opal% <4) : rem >007g; chk/keep org.pal
5820  :
5830   if cfg% =2 then
5840     if not eof(#cch) then
5850       input #cch; tmp$: cols%= '0' &tmp$     : rem >007c; min cols, 0= auto
5860       if not eof(#cch) then
5870         input #cch; tmp$: rows%= '0' &tmp$   : rem >007c; min rows
5880         if not eof(#cch) then
5890           input #cch; tmp$: shad%= '0' &tmp$ : rem >007c; shad.depth (0-4)
5900           if not eof(#cch) then
5910             input #cch; tmp$
5920             awbg= int('0' &tmp$)             : rem >007g; AW bgrd 1+, 0= false
5930           end if
5940         end if
5950       end if
5960     end if
5970   end if   : rem >007h; nested
5980   close #cch
5990  :
6000   if shad% <0 or shad% >4 then shad%= 3     : rem >007c; chk false
6010   if awbg >0 then
6020     if smde% =0 and awbg >255 then awbg= 0  : rem >007h; ? m4, o-o-range
6030     if smde% >15
6040       if awbg >k64 then awbg= 0                  : rem >007h; ! read as sys.col
6050       if awbg >1023 and awbg <16384 then awbg= 0 : rem >007h; ! 3d border
6060       if awbg >512 and awbg <768 then awbg= 0    : rem >007h; ! sys.pal
6070     end if
6080   end if
6090   if len(sprv$) then
6100     sprv%= (ftest(sprv$) =0)                : rem >007g; int
6110     if not sprv% then
6120       tmp$= GetDir$(sprv$): c%= len(tmp$)   : rem >007; get dev+dir
6130       :: if test% then
6140            tch%= fop_over(testd$): print #tch%; '> ';tmp$
6150       :: end if   : rem >T>007g; name set @ test% init
6160       if home%
6170         if c% >4 then
6180           tmp$= home$ &sprv$(c% +1 to)      : rem >007; at least 'devN_'
6190         else
6200           rem >007g; found no sub for sprv$, try home$ +jobname
6210           tmp$= home$ &sprvn$ &'_obj'       : rem >007g; org as _obj?
6220           if not (ftest(tmp$) =0) then
6230             tmp$= home$ &sprvn$ &'_exe'     : rem >007g; renamed _exe?
6240           end if
6250         end if
6260         sprv%= (ftest(tmp$) =0)
6270         if sprv% and ftyp(\tmp$) <>1 then sprv%= 0 : rem >007g; !oops, not exc
6280         if sprv% then sprv$= tmp$           : rem >007; yes, update
6290       end if
6300       :: if test% then print #tch%; tmp$: close #tch% : rem >007g;
6310     end if
6320     if sprv% then
6330       c%= 'APM' instr sprv$ : rem >007; 'SprvAPM', case-dependent!
6340       if c% then
6350         if sprv$(c% to c% +2) ='APM' then apmv%= 1 : rem >007h; if sprv
6360       end if
6370     end if
6380   else
6390     sprv%= 0
6400   end if
6410   ret 0
6420  end def GetCfg
6430  ::
6440  def proc PickJobs
6450  loc pj, jn : jn= 0
6460   rep pj
6470     JobsID sprvn$, jn
6480     if jn =0 then exit pj
6490     ptop #mch; jn
6500   end rep pj
6510  end def PickJobs
6520  ::
6530  def proc DelJobs
6540  loc dj, jn : jn= 0
6550   rep dj
6560     JobsID sprvn$, jn
6570     IF jn =0 then exit dj
6580     rjob jn, 0
6590   end rep dj
6600  end def DelJobs
6610  ::
6620  def proc JobsID (jn$,nx)
6630  rem >>>007 R: new name (ambiguous), +n (formal)
6640  loc nj
6650   rep nj
6660     nx= nxjob(nx, 0): if nx =0 then exit nj
6670     IF (jn$ instr job$(nx)) =1 then exit nj
6680   end rep nj
6690  end def JobsID
6700  ::
6710  def proc Disp (s%)
6720  rem *** Show sprite info
6730  loc s$(1), sl%
6740   sl%= len(sprn$(s%)) : rem >007; max 20 (was 10) *6 +8, +invalid
6750   if sl% <11 then sl%= 68: else sl%= 6 *sl% +8        : rem >007; more name space
6760   mwindow #wrkdf; 4! 0: wm_paper #mch; msbg: cls #mch : rem >007g; as AW
6770   wm_ink #mch; 528                                    : rem sp.infwinfg = $210
6780   cursor #mch; 4, 2: print #mch; sprn$(s%);
6790   if spid%(s%, 1) then print #mch; '.': else print #mch; '_' : rem >007e; +nfa
6800   cursor #mch; sl% +6, 2                                     : rem >007e; +space
6810   spad= sprad(s%): s$= ''
6820  :
6830   rem Get details of sprite currently displayed
6840   if peek(spad) =0 then
6850     rem System sprite
6860     spad= get_sspra(peek(spad +1))
6870   else
6880     rem Address of display sprite
6890     spad= get_fspra(spad)
6900     if spad =0 then spad= sprad(s%): s$= '*' : rem Undisplayable mode
6910     if spid%(s%, 0) =3 then s$= '#'          : rem >007; spr too big
6920   end if
6930  :
6940   if spid%(s%, 0) =-1 then
6950     print #mch; ' <INVALID SPRITE>'!         : rem >007; oops!
6960   else
6970     print #mch; xyz%(s%, 0); 'x'; xyz%(s%, 1)! '@'; xyz%(s%, 2); 'x'; xyz%(s%, 3);
6980     print #mch; ' m'; xyz%(s%, 4); s$;       : rem >007e; xyz()
6990   end if
7000   print #mch; ' '; (s% +1); '/'; scnt        : rem >007; show count
7010  end def Disp
7020  ::
7030  def proc Mess(txt$)
7040   mwindow #wrkdf; 4! 0: wm_paper #mch; msbg: cls #mch
7050   wm_ink #mch; 528 : rem sp.infwinfg = $210
7060   cursor #mch; 4, 2: print #mch; txt$
7070  end def Mess
7080  ::
7090  def proc Zap (flg)
7100  rem clr Spr list, stats >007; spid ;>007e; xyz ;>007h; flg
7110   if flg
7120     dim sprs$(0, 0, 12), stat%(0, 0), sprad(1) : rem >007; AW & adr
7130     dim sprn$(0, 10), spid%(0, 0), xyz%(0, 0)  : rem >007h; names()
7140     if not setsz then
7150       wszx%= wmnx%: wszy%= wmny%        : rem Current window size
7160     end if
7170     cszx%= smnx%: cszy%= smny%          : rem Sprite square size
7180     gszx%= 1: gszy%= gszx%              : rem Grid size 1x1
7190     sprs$(0, 0)= '@' &lin2str$(sp_nul) : rem Init only sprite
7200     stat%(0, 0)= unav%: spid%(0, 0)= 0  : rem >007 +spid
7210     scnt= 0
7220   end if
7230   if addr >0 then
7240     if apmv% then DelJobs               : rem >007h; dump Sprv's, adr gone!
7250     rechp addr: addr= 0: allspr= 0      : rem >007h; allspr
7260   end if
7270  end def Zap
7280  ::
7290  def proc Gridy
7300   gszy%= int(scnt /gszx%)
7310   if (gszx% *gszy%) <scnt then gszy%= gszy% +1
7320  end def
7330  ::
7340 :rem:-procs-bsjr
7350  def fn Rd_SprFile (chn, fln, xt$, xd$)
7360  rem >>>007 N:..19.03.14; +xt$ [#getsprs]
7370  loc fnl%, d% : d%= 0
7380   if fln <66 then ret 0   : rem >007d; ? length (+64!), 2 for sys
7390   rem:: pze= item_select('Rd_Spr', 'len= ' &fln, 'test')
7400   bget #chn\ pos +5, ft%  : rem >>> file type
7410   if ft% =255 then ret 0  : rem >007; ! dir: QL=$FF, Msd=$10FF
7420   get #chn\ pos +14, fnm$
7430   fnl%= len(fnm$)
7440   if fnl% <4 then ret 0   : rem >007d; at least 4 for next line
7450   if fnm$(fnl% -3 to fnl%) ==xt$ then
7460     d%= 1
7470   else
7480     if fnm$(fnl% -3 to fnl%) ==xd$ then
7490       d%= -1
7500     else
7510       ret d%              : rem >007e; not '_spr' or '.spr'
7520     end if
7530   end if
7540   ret d% *fnl%            : rem >007e; neg flags '.spr'
7550  end def Rd_SprFile
7560  ::
7570  def fn GetDir$ (f$)
7580  rem >>>007; copy/adapt from S_APMv010
7590  loc e%, dc%, s%, t%
7600   e%= len(f$) -4                             : rem >>> assume '_spr' ext
7610   for s% =e% to 1 step -1
7620     if f$(s%) ='_' then
7630       dc%= fop_in(f$( to s%))                : rem >>> chk for dir
7640       if dc% <0 then next s%                 : rem >>> can't open part name
7650       t%= ftyp(#dc%)
7660       if t% <>255 and t% <>4351 then next s% : rem >>> not QL or Msd dir
7670       exit s%                                : rem >>> must be dir
7680     end if
7690   end for s%
7700   if dc% >0 then close #dc%                  : rem >007g; !Fop never uses 0/2
7710   if f$(s%) ='_' then ret f$(1 TO s%)        : rem >007g; ret dir with '_'
7720   ret ''                                     : rem >007g; no dir
7730  end def TrimDir$
7740  ::
7750  def proc CellMax
7760  rem >>>007g N: re/set max possible cell [#init]
7770   cmxx%= (wmxx% -cols% *2 -2) /cols% : rem >007e; max cell for scr ..
7780   cmxy%= (wmxy% -rows% *2 -2) /rows% : rem >007c; .. minus cell-border
7790   vrws%= cmxy% : rem >007c; keep visible rows
7800  end def
7810  ::
7820  def proc MaxCells (clc%, csz%, smx%)
7830  rem >>>007e N: calc max cells for given size
7840  loc i%, max
7850   for i% =1 to clc%
7860     max= i% *csz% +i% *2 +6 : rem >>> find max cols/rows that fit
7870     if max >=smx% then clc%= i% -1: exit i%
7880   end for i%
7890  end def
7900  ::
7910  def proc MawPaper (wdf, awp, msp, flg)
7920  rem >007b N: change AW paper [suq2,arrow_bar];>007g;
7930  rem >007g; set awp & ret msp for mess/disp paper
7940  loc apw%, alst, appw, matr, watr
7950   if awp =0 then ret                : rem >007g; no bkgr so skip
7960   apw%= peek_w(wdf +110)            : rem >>> nof AWs (=1)
7970   if apw% <>1 then ErMess -4, 2     : rem >>> !oops
7980  :
7990   alst= peek_l(wdf +112)            : rem >>> AW work list
8000   appw= peek_l(alst)                : rem >>> only 1 aw =first adr
8010   watr= appw +8 +6                  : rem >007g; AW attr
8020   if flg <=0 then msp= peek_w(watr) : rem >007g; get org paper
8030   :
8040   if flg then
8050     poke_w watr, awp                : rem >>> chge AW paper, only org.pal
8060     matr= (appw +104 +4)            : rem >007g; menu attr, unav
8070     poke_w matr, awp                : rem >007g; set unav as AW paper
8080   end if
8090  end def
8100  ::
8110  def proc ErMess (erv, flg)
8120  rem >>>007h N: all error reports
8130  loc f% : f%= abs(flg)
8140   if erv >=0 then ret
8150   if flg <=0 and cmpl% then
8160     outl #1; 400, 200, 20, 20 : rem >007i; for error wndo
8170   end if
8180  :
8190   sel on f%
8200     =0 : erv= item_select('MSPRV','Window Manager too old!','OK')
8210     =1,2 : report_error erv,,,pal% : rem >>> 1=_cfg, 2=EP error
8220      if f% =2 then stop            : rem >007i; 0,1 cfg ret, stop later
8230   end sel
8240  end def
8250  ::
8260  REMark $$off
8270  def proc Tarray (flg)
8280  rem >>>007e N: print test arrays, not qlibd
8290  loc c%, tr%, k%, tc% : tc%= flg: k%= 0
8300   sel on tc%
8310     =1 :  rem >>> adr array
8320       close #1
8330       tc%= fop_over(#1, 'ram1_MsprvAW_dmp')
8340       if tc% <0 then ret
8350       print #1; 'Test Sprite List, ' &date$\ 'count =';scnt
8360       print #1; 's2big =' &lin2str$(sp_big)\ 'spgd2 =' &lin2str$(sp_gd2)
8370       for tr% =0 to gszy% -1
8380         for c% =0 to gszx% -1
8390           print #1; sprn$(k%), lin2str$(sprad(k%)), sprs$(c%, tr%),
8400           print #1; xyz%(k%, 0); 'x'; xyz%(k%, 1)! 'm'; xyz%(k%, 4)
8410           k%= k% +1: if k% =scnt then exit tr%
8420         end for c%
8430       end for tr%
8440       close #1
8450   end sel
8460  end def
8470  REMark $$on
8480  ::
8490  def proc Tinfo (wt%)
8500  rem >>>007 N: 26.03.14; test info
8510  loc a%, a$ : a%= 0
8520   a$= 'version: ' &beta$ &', ' &datm$
8530   a$= a$ &'\root   : ' &root$
8540   if home% then a$= a$ &'\home   : ' &home$
8550   a$= a$ &'\default: ' &ddir$
8560   a$= a$ &'\current: ' &ldir$
8570   a$= a$ &'\viewer : ' &sprv$
8580   a$= a$ &'\vw.name: ' &sprvn$
8590   a$= a$ &'\grid   : ' &gszx% &'x' &gszy%
8600   if cols% >1 then
8610     a$= a$ &' (page: ' &cols% &'x' &rows% &')'
8620   end if : rem >007b; cfg 02
8630   if test% then
8640     wt%= 0 : rem >007e; no timeout for test
8650     a$= a$ &'\config : ' &cfg% &', sprs: ' &scnt &', size: ' &lin2str$(allspr)
8660     a$= a$ &'\appwndo: ' &wszx% &'x' &wszy% &', max: ' &wmxx% &'x' &wmxy% : rem >007e >007h; +allspr
8670     a$= a$ &'\cellcur: ' &cszx% &'x' &cszy% &', max: ' &cmxx% &'x' &cmxy% : rem >007i;
8680     a$= a$ &'\spv/apm: ' &sprv% &'/' &apmv%
8690     a$= a$ &', shad: ' &shad% : rem >007c; cfg 02
8700     a$= a$ &', vrws: ' &vrws% : rem >007c; scroll
8710     a$= a$ &'\aw/msbg: ' &awbg &'/' &msbg &' pal: ' &pal% &'/' &opal%
8720   end if
8730   if wt% then a%= 800
8740   a%= item_select('MSPRV INFO', a$, 'OK',,,,, a% *k64)
8750  end def Tinfo
8760  ::
8770 :rem:-end-of-basic
