1000 :rem:-basic-top
1010  rem *** Sprite viewer
1020  rem *** pjwitte February 8th 2004
1030  rem *** V0.07 - see history
1040  rem >>> v0.08b - bsjr 15.04.05;
1050  rem >>>  show sprite at address if CMD$ = 'Sprv@name$xxxxxxxx%n'
1060  rem >>>  id, title to use, sprite address, palno or address
1070  rem >>> v0.09a - bsjr 21.04.06; add save as _pic
1080  rem >>> v0.09b - bsjr 14.10.10; upd, bug fix
1090  rem >>> v0.10a - bsjr 12.03.14; upd, bug fix
1100  rem >>> v0.10b - bsjr 14.03.14; +dyna
1110  rem >>> v0.10c - bsjr 27.03.14; final?
1120  rem >>> v0.10f - bsjr 14.04.14; final?, -mcallt
1130  rem >>> v0.10g - bsjr 01.05.14; final?, fxd rechp sys.spr if not file
1140  rem >>> v0.10h - bsjr 19.06.14; final?, +show m8
1150  rem >>> v0.10i - bsjr 05.07.14; final?, fix gd2 on m4, Aur
1160  :
1170  EXT_FN 'MN_SPRV','GET_SSPRA','GET_FSPRA','MNU_001'
1180  EXT_FN 'DMODE','WMAVER$'
1190  :
1200  REMark $$chan=4
1210  REMark $$stak=512
1220  REMark $$asmb=dev8_Per_Spv_sprv_bin,0,10
1230  REMark $$asmb=dev8_Per_My_Spv_spverr_bin,0,10
1240  REMark $$asmb=dev8_Lib_R_Display_cde,0,10
1250  :
1260  beta$= '0.10.09': datm$= '2014-07-14'
1270  cmpl%= 1:: test%= 0           : rem >009b; compile flag >010i; +test
1280  if ver$ <>'HBA' then cmpl%= 2 : rem >010h; ?qdos, chk >H>
1290  REMark $$off
1300  rem *** develop under QD/SMSQE >009b; Qlib off/on
1310  if peek$(\\-4, 4) ='SBAS' then
1320    lrespr 'dev8_Per_spv_sprv_bin'
1330    ermnu= alchp(144)
1340    lbytes 'dev8_Per_My_Spv_spverr_men', ermnu
1350    lrespr 'dev8_lib_R_display_cde' : rem >010h; dmode,wma
1360    cmpl%= 0: job_name 'SprvAPM!'   : rem >008b;
1370    test%= 1                        : rem >T>010i;
1380  end if
1390  REMark $$on
1400  if cmpl% then ermnu= MNU_001      : rem >010c; error menu
1410  :
1420  c$= CMD$: pal%= 0:  n$= ''        : rem Default palette >009b; n$
1430  cadr= 0: syspal= 0: fln= 0
1440  rem >008b; chk cmd$ for adr, name & pal val/adr
1450  if len(c$) then
1460    cadr= Chk_SprAdr(c$, n$, pal%, syspal)
1470    if cadr then c$= '$'            : rem >008b; got valid address
1480  end if
1490  :
1500 :rem:-begin-program
1510   Sprv_Init: Sprv_Main
1520  stop
1530  ::
1540 :rem:-Init
1550  def proc Sprv_Init
1560  rem >>>010a R: Initialise
1570   dim pr%(16)
1580   serr%= 0            : rem >010e; spr error
1590   type%= 0: ql%= 1    : rem >010g; init type >010i; ofs for Inf2/xtnd
1600   mxnl%= 13           : rem Max name length in chrs
1610   lisz%= 116          : rem Min. Sprite LI size in px
1620   txw% = 19           : rem Info text width
1630   sp_titletxtbg%= 517 : rem Title text background
1640   sp_titlefg%   = 518 : rem Title foreground
1650   sp_litemavabg%= 520 : rem Loose item available background
1660   sp_litemavafg%= 521 : rem Loose item available foreground
1670   sp_litemselbg%= 522 : rem Loose item selected background
1680   sp_litemselfg%= 523 : rem Loose item selected foreground
1690   sp_litemunabg%= 524 : rem Loose item unavailable background
1700  :
1710   rem Extract pal >008b; ='$' if cadr from APM
1720   if len(c$) =0 then
1730     c$=read_string$('Filename for Sprite',c$,,50)    : rem >010a; one chance only
1740     if '%T%' instr c$ =1 then test%= 1: c$= c$(4 to) : rem >T>010i;
1750   end if
1760  :
1770   if len(c$) then
1780     p%= ' %' instr c$
1790     if p% >0 then
1800       if len(c$) >(p% +1) then pal%= c$(p% +2 to)
1810       for i% =p% to 1 step -1 : if c$(i%) <>' ' then exit i%
1820       c$= c$(1 to i%)
1830     end if
1840   else
1850     serr%= -7 : rem >010a; ! always need fname/adr >010e; serr
1860   end if      : rem >010e; chk len, '$' =ok or longer
1870  :
1880   rem >>> get chan, scr size
1890   dmd4%= (dmode >0 and dmode <16) : rem >010i; =m8
1900   if dmd4% then mode 4            : rem >H>010i; force mode 4 if m8
1910   if dmode =0 then dmd4%= 1       : rem >010i; now flag m4
1920   mch= fopen('con_0x0'): outl #mch: rdpt #mch; 48
1930   flim #mch; xm%, ym%, xo%, yo%
1940   serr= wmaver$(#mch): if serr >=2 then serr= 0: else serr= -19
1950   close #mch : rem >H>010h; chk WM v2
1960  :
1970   rem >008b; syspal 0/4 from APM
1980   if pal% =4 and cadr then
1990     sp_jobownpal -1, syspal : rem >008b; adr from APM
2000   else
2010     sp_jobpal -1, pal%
2020   end if
2030  :
2040   rem >008b; load fname, skip if cadr
2050   if not serr% then
2060     if not cadr then
2070       mch= fop_in(c$)
2080       if mch >=0 then
2090         fln= flen(#mch)      : rem >010g; chk length >=2
2100         if fln >1 then
2110           addr= alchp(fln)
2120           if addr >0 then
2130             lbytes c$, addr  : rem >010g; +close later
2140             n$= TrimDir$(c$) : rem >009b; trunc fname
2150           else
2160             serr%= addr      : rem >010g; ? mem error
2170           end if
2180         else
2190           serr%= -15         : rem >010g; ? zero length, 2 can be sys.spr
2200         end if
2210         close #mch           : rem >010g;
2220       else
2230         serr%= mch           : rem >010g; chan error
2240       end if
2250     else
2260       addr= cadr             : rem >008b; it's cadr
2270     end if
2280   end if
2290  :
2300   rem >>> get type/mode 1st spr >010g; not if serr% set earlier
2310   smdh%= 0: smd8%= 0 : rem >010i; flag 1st mode for m4
2320   if not serr% then
2330     type%= peek(addr): sspr%= peek(addr +1)   : rem >010a; flag type
2340     if sspr% <0 or sspr% >64 then serr%= -15  : rem >010a; ? valid mode
2350     IF type% =0 then
2360       if not cadr then rechp addr : rem release index >010g; only if file
2370       addr= get_sspra(sspr%)      : rem System sprite address (0-37)
2380       type%= peek(addr)           : rem >>> new type
2390     else
2400       if type% <0 or type% >2 then serr%= -15 : rem >010e; ? valid type
2410       smd8%= (sspr% =1 or sspr% =8)           : rem >010i; flag m8 QL/gd2
2420       smdh%= (type% =2)                       : rem >010i; flag gd2
2430       sspr%= -1
2440       if type% =1 then ql%= ql% +1            : rem >00i; offset for Inf2
2450     end if
2460     if dmd4%
2470       strt= get_sspra(3): spm8= alchp(192)    : rem >010i; reserve 2x96b
2480       for i% =0 to 190 step 2 : poke_w spm8 +i%, peek_w(strt +i%)
2490     end if  : rem >010i; copy of sspr for ptr
2500   end if
2510  :
2520   if not cadr and sspr% <0 then
2530     sel on type% =1,2 : if fln <32 then serr%= -15 : rem >010g; too short
2540   end if
2550  :
2560   if not serr% then
2570     if type% =2 then hddr= LdHdSpr(addr): else hddr= LdHdSpr(0)
2580     rem >009b; dummy needed for old EP >010i; also used for m4 ptr
2590     sx%= peek_w(addr +4): sy%= peek_w(addr +6)
2600     if sx% <1 or sx% >(xm% -40) then serr%= -4 : rem >>> chk min/max size..
2610     if sy% <1 or sy% >(ym% -40) then serr%= -4 : rem >010e; flag oversize
2620   end if
2630   if serr% then sx%= 1: sy%= 1                 : rem >010e; force min size
2640   IF sx% <(lisz% -2) then xs%= lisz%: else xs%= sx% +2 : rem >>> minimum
2650   IF sy% <(lisz% -2) then ys%= lisz%: else ys%= sy% +2
2660   xp%= (xs% -sx%) div 2: yp%= (ys% -sy%) div 2 : rem >010a; x/y menu pos
2670  :
2680   rem >>> fit fname >010a; Centre
2690   n$= Centre$(n$, mxnl%)
2700  end def Sprv_Init
2710  ::
2720 :rem:-main
2730  def proc Sprv_Main
2740  rem >>>010a P: draw menu, +er%
2750   mch= fopen('con_'): er%= mch: outl #mch
2760   msetup #er%, mn_sprv, -1, -1, xs% +30, ys% +30: Erm er%, 177
2770   minob #er%\ 3, 1, n$:: rem pause #mch; -1    : rem >>> title
2780   if serr% then type%= 0: addr= get_sspra(1)   : rem >010e; error do padlock
2790   if type% =2 then cspr= hddr: else cspr= addr : rem >010b; gd2 dummy or real
2800   mitem #er%\ -3, -2, cspr: mdraw #er%: pause #er%; 20
2810   if serr% then Erm serr%, 182 : rem >010e; ?oversized/invalid ->quit
2820  :
2830   s%= 0: ky= 0: IniSpr: IniTimer 1 : rem >010b; set event/dyna/time
2840   repeat dl
2850     ky= mcall(#er%, ky, s%): pval #er%, pr%
2860     sel on ky
2870       =-1 :  rem Wmove (CF4) by EP
2880       =-2 :  rem ESC (27)
2890          rem:: if pr%(5) =2 then Erm -23, 190: next dl : rem >T>010;
2900          mclear #er%: clamp: close #mch: ret
2910       =-3 :  rem Sprite (Tab); Hit= avail/curr, DO= unav, Wake to unDo
2920         if pr%(5) =2 then
2930           s%= mstat%(#er%, ky to -1)
2940         else
2950           s%= mstat%(#er%, ky)
2960         end if
2970       =-4 :  rem Info (F1)
2980         Dyna_off : rem >010e;
2990         if inf% and (shw% =-1 or shw% >0) then
3000           inf%= 0: ShowSpr cspr, 0 : rem >010i; flag save
3010         else
3020           inf%= 1
3030           if cspr <addr then
3040             IniSpr : rem >>> reset spr to 1st adr
3050             if not dmd4% and peek(cspr) >0 then
3060               repeat gdl
3070                 rem >H> Find first available sprite for this mode
3080                 if peek(cspr) =2 then exit gdl
3090                 shw%= Next_Valid(cspr) : rem >010b; chk, next or zero
3100                 if NOT shw% then exit gdl
3110               end rep gdl
3120               if cspr <addr then IniSpr
3130             end if
3140           end if
3150           Info
3160         end if
3170         s%= 0
3180       =-5 :  rem Down (D); Hit= next spr, DO= reset to 1st, dyna on/off
3190         if pr%(5) =2 then
3200           if not sprd% and dn% then
3210             if sx% *sy% <=4096 then
3220               IniSpr : rem >010i; px limit
3230               sprs #er%, cspr: sprd%= 1 : rem *007; show dyna
3240               beep 20, 2
3250             else
3260               beep 999, 999
3270             end if
3280           else
3290             Dyna_off : rem >010e; off
3300           end if
3310         else
3320           if cspr >=addr then
3330             NextSpr shw% : rem >010g; set shw
3340             if dmd4% and not sprd% then ChkPtr 1 : rem >010i; ptr
3350           end if
3360         end if
3370        :
3380         if cspr <addr then IniSpr
3390         sel on shw% =-3 to -130 : inf%= 1 : rem >>010g; oversized, force info
3400         if inf% then Info: else ShowSpr cspr, 0
3410         s%= 0
3420       =-6 :  rem Wake/Reset (^F2/Hit, DO= chk m8)
3430         if pr%(5) =2 and (smd8% or shw% =2) then
3440           if not inf% then ShowMode8 cspr, -1 : else next dl : rem >010h; chk m8
3450         else
3460           Dyna_off: IniSpr         : rem >010e; off >010b; reset
3470           mdraw #er%: Erm er%, 248 : rem >010a; erm
3480           mitem #er%, -3, -2, cspr : rem >010b; show 1st
3490         end if
3500         s%= mstat%(#er%, -3 to 0): inf%= 0
3510       =-7 :  rem Palette (P)
3520         if pr%(5) =2 and (shw% =-1 or shw% >0) then
3530           Save2Pic addr
3540           s%= mstat%(#er%, ky to 0): next dl : rem >009a;>010c;
3550         end if
3560         pal%= (mtext$(#er%, ky) +1) mod (4 +(syspal <>0))
3570         if pal% =4 then
3580           sp_jobownpal -1, syspal
3590         else
3600           sp_jobpal -1, pal%
3610         end if
3620         mdraw #er%: Erm er%, 263 : rem >010a; erm
3630         mitem #er%, ky, 0, '' &pal%
3640         s%= 0
3650     end sel
3660   end rep dl
3670  end def Sprv_Main
3680  ::
3690 :rem:-procs_
3700  def proc IniSpr
3710  rem *** Reset GLObal variables
3720   cspr= addr: blk= 0: ofs%= 0: lspr= 0: sprno%= 1
3730   sprd%= 0: shw%= 1: sprs #er%, 0 : rem *007; +dyna >010g; +shw
3740   if dmd4% then ChkPtr inf%       : rem >010i; set ptr
3750  end def IniSpr
3760  ::
3770  def proc Info
3780  rem *** show info
3790   mwindow #er%, -3: Erm er%, 280: cls #mch: over #mch; 0 : rem >010a; erm
3800   wm_ink #mch; sp_titlefg%: wm_paper #mch; sp_titletxtbg%: cls #mch; 3
3810  :
3820   type%= peek(cspr)
3830   if sspr% >=0 and sprno% =1 then
3840     Inf0
3850   else
3860     sel on type%
3870       =1 : Inf1   : rem Standard QL colour sprite
3880       =2 : Inf2 1 : rem GD2 colour sprite >010i; parm
3890       =remainder  : Dis 'Type not defined', ''
3900        if test%
3910          Dis ' ss:' &sspr% &' no:' &sprno%, ''
3920          Dis ' tp:' &type%,''
3930          Dis 'ad:' &fdec$(cspr, 8, 0), ' md:' &shw%
3940        end if  : rem >T>010i;
3950        cspr= 0 : rem >010i; force reset
3960     end sel
3970   end if
3980  end def Info
3990  ::
4000  def proc Inftxt (txt$)
4010   print #mch; Centre$(txt$, txw%)
4020   wm_ink #mch; sp_litemavafg%: wm_paper #mch; sp_litemavabg%: cls #mch; 2
4030  end def Inftxt
4040  ::
4050  def proc Inf0
4060   loc it$
4070   it$= 'System sprite: ' &sspr%: Inftxt it$ : rem >010g; txt too long for 2 chrs
4080   rem >010g; show 'real' stats
4090   sel on type%
4100     =1 : Inf1   : rem >010g; QL spr
4110     =2 : Inf2 0 : rem GD2 colour sprite ?010i; parm
4120     =remainder  : print #mch; it$\'Type not defined'
4130      cspr= 0 : rem >010i; it$, force reset
4140   end sel
4150  end def Inf0
4160  ::
4170  def proc Inf1
4180   Inftxt 'QL-colour sprite'
4190   if peek(cspr +1) =0 then Dis 'mode', 4: else Dis 'mode', 8
4200   Time
4210   Dis 'adapt ', hex$(peek(cspr +3), 8)
4220   Dis 'x-size', peek_w(cspr +4)
4230   Dis 'y-size', peek_w(cspr +6)
4240   Dis 'x-orig', peek_w(cspr +8)
4250   Dis 'y-orig', peek_w(cspr +10)
4260   if test% then Dis 'ad:' &fdec$(cspr, 8, 0), ' md:' &shw% : rem >T>010i;
4270   print #mch: Dis 'Sprite no', sprno%
4280  end def Inf1
4290  ::
4300  def proc Inf2 (h%)
4310  loc i%, cm%, cc%, xt%, msk, no$
4320   if h% then Inftxt 'GD2-colour sprite'
4330   cm%= peek(cspr +1): cc%= 0 : rem >010a; chk line count
4340   sel on cm%
4350     = 0 : Dis '1 bit black&white', cm%
4360     = 3 : Dis '1 bit pal mapped', cm%
4370     = 4 : Dis '2 bit fixed pal', cm%
4380     = 7 : Dis '2 bit pal mapped', cm%
4390     = 8 : Dis '4 bit fixed pal', cm%
4400     =15 : Dis '4 bit pal mapped', cm%
4410     =16 : Dis '8 bit fixed pal', cm%
4420     =31 : Dis '8 bit pal mapped', cm%
4430     =32 : Dis '16 bit QPC/QXL', cm%
4440     =33 : Dis '16 bit Q40+', cm%
4450     =64 : Dis '32 bit RGB', cm%               : rem >010a; ='0RGB'
4460     =remainder : Dis 'Unknown bit sample!','' : rem >010a; unlikely
4470   end sel
4480   Time
4490   cm%= peek(cspr +3): cc%= cm% && 3 : rem Sprite control:
4500   if cc% >0 then Dis 'cache', cc%   : rem >010a; also flags xtra line
4510   Dis 'sprite block ', Tstb$(cm%, 4)
4520   Dis 'option block ', Tstb$(cm%, 8)
4530   Dis 'alpha channel', Tstb$(cm%, 32)
4540   Dis 'pattern compr', Tstb$(cm%, 64)
4550   msk= peek_l(cspr +16)
4560   if msk ==0 then
4570     Dis 'mask solid', Tstb$(1, 1) : rem >010a; solid
4580   else
4590     Dis 'mask compr', Tstb$(cm%, 128)
4600   end if
4610   Dis 'x/y-size', peek_w(cspr +4) &'/' &peek_w(cspr +6)
4620   Dis 'x/y-orig', peek_w(cspr +8) &'/' &peek_w(cspr +10)
4630   no$= '': if test% then no$= 'ad:' &fdec$(cspr, 8, 0) &' md:' &shw% : rem >T>010i;
4640   if ys% +30 <=155 then
4650     if NOT cc% then Dis no$,''
4660   else
4670     Dis no$,'' : rem >010a; max 12 lines in dft wndo (146x146)!
4680   end if
4690   if blk then
4700     for i% =0 to 4 : if xblk(i%) ==cspr then exit i%
4710     no$= sprno% &' (' &(i% +ql%) &')' : rem >010i; match real spr
4720     sel on ofs%
4730       = 0 : Dis 'Avail',no$
4740       = 4 : Dis 'Avail & Curr',no$
4750       = 8 : Dis 'Sel',no$
4760       =12 : Dis 'Sel & Curr',no$
4770       =16 : Dis 'Unavail',no$
4780      end sel
4790   else
4800     Dis 'Sprite no', sprno%
4810   end if
4820  end def Inf2
4830  ::
4840  def proc Dis (l$, d$)
4850   print #mch; l$; to (txw% -len(d$)); d$
4860  end def Dis
4870  ::
4880  def proc Time
4890  rem >>>009b R: 17.10.10; +tim%
4900  loc tim%
4910   tim%= peek(cspr +2)
4920   sel on tim%
4930     =0 : Dis 'time', 'static'
4940     =remainder : Dis 'time', tim%
4950   end sel
4960  end def Time
4970  ::
4980  def fn Tstb$ (v%, b%)
4990   if v% && b% then ret 'Yes': else ret 'No'
5000  end def Tstb$
5010  ::
5020  def proc ShowSpr (adr, sv%)
5030  rem *** Isolate and display sprite >010i; +save flag
5040  loc ladr, x%, y%, xo%, yo%
5050   mwindow #er%, -3: Erm er%, 406: over #mch; 0
5060   x%= mstat%(#er%, -3) : rem Get current status
5070   sel on x%
5080     =-1 : wm_paper #mch; sp_litemunabg%
5090     = 0 : wm_paper #mch; sp_litemavabg%
5100     = 1 : wm_paper #mch; sp_litemselbg%
5110   end sel
5120   cls #mch
5130   x%= (xs% -peek_w(adr +4) +6) div 2
5140   y%= (ys% -peek_w(adr +6) +6) div 2
5150   if sspr% >=0 then
5160     rem Dont poke about in systems sprites!
5170     sprw #er%, x%, y%, adr                    : rem >>> assume org is 0,0
5180   else
5190     xo%= peek_w(adr +8): yo%= peek_w(adr +10)
5200     poke_l adr +8, 0                         : rem >>> unset spr.org
5210     ladr= peek_l(adr +20): poke_l adr +20, 0 : rem >>> unset pto.nxt
5220     sprw #er%, x%, y%, adr
5230     if er% <0 then er%= mch: adr= 0          : rem >010i; force reset
5240     poke_l adr +20, ladr                     : rem >>> restore pto.nxt
5250     poke_w adr +8, xo%: poke_w adr +10, yo%  : rem >>> restore spr.org
5260   end if
5270   if sv% and adr >1 then SavPic 1            : rem >010i; save as pic
5280   if dmd4% and not sprd% then ChkPtr inf%    : rem >010i; set ptr
5290  end def ShowSpr
5300  ::
5310  def proc NextSpr (nx%)
5320  rem *** Caller's spr, blk and ofs% >010g; nx%= shw%
5330  rem *** First do blocks, then chain along
5340   if blk then
5350     NxtdSpr (nx%)
5360   else
5370     cm%= peek(cspr +3)
5380     if (cm% && 4) <>0 then
5390       dim xblk(4): nx%= peek(cspr +1) +64 : rem >010i; flag mode gd2
5400       blk= peek_l(cspr +28) +cspr +28     : rem blk= pto avail in spr block
5410       lspr= cspr: cspr =peek_l(blk) +blk  : rem >>> adr of avail
5420       xblk(0)= cspr                       : rem >010i; keep adr
5430     else
5440       nx%= Next_Valid(cspr)               : rem >010a; pto.nxt valid or zero
5450     end if
5460   end if
5470   if cspr >=addr then sprno%= sprno% +1: else sprno%= 0: nx%= 0 : rem >010a; only if valid
5480  end def NextSpr
5490  ::
5500  def proc NxtdSpr (n%)
5510  rem *** Extended, Recursive
5520   ofs%= ofs% +4
5530   if ofs% >16 then
5540     blk= 0: ofs%= 0: cspr= lspr
5550     if lspr ==0 then ret                       : rem >>> ? will never happen
5560     n%= Next_Valid(cspr)                       : rem >010a; ? valid or zero
5570   else
5580     if peek_l(blk +ofs%) ==0 then NxtdSpr (n%) : rem >>> ? empty Extd
5590     cspr= peek_l(blk +ofs%) +blk +ofs%
5600     xblk(ofs% div 4)= cspr                     : rem >010i; keep adr for Inf2
5610   end if
5620  end def NxtdSpr
5630  ::
5640  def fn Centre$ (txt$, max%)
5650  rem *** Centre text; >010a; +max%
5660   if len(txt$) <max% then
5670     ret fill$(' ', (max% -len(txt$)) div 2) &txt$
5680   else
5690     ret txt$(1 to max%)
5700   end if
5710  end def Centre$
5720  ::
5730  def proc Erm (er, fat)
5740  rem *** Not finished >010b; report wndo
5750   if er >=0 then ret
5760   if NOT fat then ret : rem >010a; not fatal, no mesg
5770   erw%= fopen('con_')
5780   mdraw #erw%, ermnu, 0, 0, 140, 68 : rem >010b; 2nd wndo
5790   mwindow #erw%; 1!
5800   wm_paper #erw%; 556: wm_ink #erw%; 514: cls #erw%
5810   wm_border #erw%; 2, 556: print #erw%; 'ERROR:'
5820   report #erw%; er: print #erw%; '@ line: ' &fat
5830   rdpt #erw%, 1
5840   mclear #erw%: close #erw%
5850   if cmpl% then stop : rem Quit with error!
5860  end def Erm
5870  ::
5880  def fn LdHdSpr (adr)
5890  rem *** EasyPtr2/3's MITEM cant handle complex sprites
5900  rem *** So this inserts a QL sprite in front to fool EP (and Wman1)
5910  rem *** Wman2 knows about hi-def sprites, SPRS and WSPR
5920  rem *** will display correctly. Wman1 will display a ?
5930  loc po, wi, hd, nx
5940  :
5950   restore
5960   hd= alchp(120): nx= 0 : rem >010i; new shape
5970   for po =hd to hd +118 step 2 : read wi: poke_w po, wi
5980   if adr >1 then nx= adr -hd -20
5990   poke_l hd +20, nx     : rem >010i; zero if used as ptr only
6000   ret hd                : rem >010h; as fn
6010  :
6020   rem >010i; new m4 'GD2'
6030   data 256,0     : rem dc.b  $1,$0,$0,$0
6040   data 16,12     : rem dc.w  $10,$C
6050   data 0,0       : rem dc.w  0,0
6060   data 0,12      : rem dc.l  q4p-*
6070   data 0,56      : rem dc.l  trans-*
6080   data 0,0       : rem dc.l  ???-*
6090  :
6100  rem q4p
6110   data 21845,21845   : rem dc.w  $5555,$5555
6120   data -32513,254    : rem dc.w  $80ff,$00fe ;33023,
6130   data 4479,-30209   : rem dc.w  $117f,$89ff ;,35327
6140   data -22017,21758  : rem dc.w  $a9ff,$54fe ;43519,
6150   data 10623,22015   : rem dc.w  $297f,$55ff
6160   data -24065,17662  : rem dc.w  $a1ff,$44fe ;41471,
6170   data 8575,19967    : rem dc.w  $217f,$4dff
6180   data -20993,22782  : rem dc.w  $adff,$58fe ;44543,
6190   data 10623,20991   : rem dc.w  $297f,$51ff
6200   data -17921,-25346 : rem dc.w  $b9ff,$9cfe ;47615 ,40190
6210   data 127,511       : rem dc.w  $007f,$01ff
6220   data -21846,-21846 : rem dc.w  $aaaa,$aaaa ;43690
6230  :
6240  rem trans
6250   data -1,-1     : rem dc.w  $ffff,$ffff
6260   data 32896,257 : rem dc.w  $8080,$0101
6270   data 32896,257 : rem dc.w  $8080,$0101
6280   data 32896,257 : rem dc.w  $8080,$0101
6290   data 32896,257 : rem dc.w  $8080,$0101
6300   data 32896,257 : rem dc.w  $8080,$0101
6310   data 32896,257 : rem dc.w  $8080,$0101
6320   data 32896,257 : rem dc.w  $8080,$0101
6330   data 32896,257 : rem dc.w  $8080,$0101
6340   data 32896,257 : rem dc.w  $8080,$0101
6350   data 32896,257 : rem dc.w  $8080,$0101
6360   data -1,-1     : rem dc.w  $ffff,$ffff
6370  :
6380  end def LdHdSpr
6390  ::
6400 :rem:-procs_bsjr
6410  def fn Chk_SprAdr (var$, nme$, pl, pla)
6420  rem >>>008b N: var$='Sprv@name$xxxxxxxx%n'
6430  rem >>> name can be empty, %n can be left out or %$xxx.. as pal adr
6440  loc p%, v$, lv%, a$
6450   lv%= len(var$): if lv% <14 then ret 0 : rem >009b; ! too short
6460   if var$(1 to 6) <>'Sprv@' then ret 0 : rem >>> ! no id
6470  :
6480   p%= '%' instr var$: v$= var$
6490   if p% and p% <lv% then
6500     a$= var$(p% +1 to)
6510     if a$(1) instr '0123' then pl= a$(1)
6520     if a$(1) ='$' then
6530       if len(a$) =9 then pla= Hex2Adr(a$)    : rem >>> $ & 8 chrs
6540       if pla then pl= 4: else pl= 0
6550     end if
6560     v$= var$(1 to p% -1)                     : rem >>> trim palette
6570   else
6580     pl= 0                                    : rem >009b; ! no pal value, dft 0
6590   end if
6600  :
6610   nme$= 'sprite': v$= v$(7 to): lv%= len(v$) : rem >>> trim id
6620   p%= '$' instr v$: lv%= lv% -8
6630   if p% <1 or p% <>lv% then nme$= '': ret 0  : rem >>> no $ or 8 chrs
6640   if p% >1 then nme$= v$(1 to p% -1)
6650   a$= v$(p% to): ret Hex2Adr(a$)             : rem >>> $ & 8 chrs
6660  end def Chk_SprAdr
6670  ::
6680  def fn Hex2Adr (h$)
6690  rem >>>008b N:
6700  loc i%
6710   for i% =2 to 9
6720     if not h$(i%) instr '1234567890ABCDEF' then ret 0 : rem >>> not hex
6730   end for i%
6740   ret hex(h$(2 to)) : rem >>> so far so good
6750  end def Hex2Adr
6760  ::
6770  def fn Next_Valid (adr)
6780  rem >>>010a N: ? is this a valid spr, chk form & size
6790  rem >>>010g; return r% = shw%: -1 = sspr, 0 = invalid, 1 m4, 2 = m8,
6800  rem >>>010i; 64 +m = gd2, -3/-130 = oversized (-(n+2)), can't show
6810  loc nxt, m%, t%, w%, h%, p%, q%, r%
6820   nxt= peek_l(adr +20): if nxt <=0 then adr= 0: ret 0 : rem >010i; neg false?
6830   if not cadr then
6840     if nxt +20 >fln -32 then adr= 0: ret 0 : rem >010i; not within len
6850   end if
6860  :
6870   rem >!!! if NOT 0 there may still be NO next
6880   nxt= adr +20 +nxt
6890   if nxt <addr then adr= 0: ret 0 : rem >010i; must be false adr!
6900  :
6910   t%= peek(nxt): m%= peek(nxt +1): r%= 0
6920   sel on t%
6930     =1 : sel on m% =0,1     : r%= 1 +m%: ql%= ql% +1 : rem >010i; 2= m8, ofs for Inf2
6940     =2 : sel on m% =0,3,4,7,8,15,16,31,32,33,64 : r%= 64 +m% : rem >010i; 72= m8
6950     =remainder : r%= 0 : rem >010g; invalid, >010i; sspr incl!
6960   end sel
6970  :
6980   if r% then
6990     w%= peek_w(nxt +4): h%= peek_w(nxt +6)
7000     if w% <1 or w% >2048 then r%= 0 : rem >010g; chk min/max
7010     if h% <1 or h% >1536 then r%= 0
7020   end if
7030   if r% then
7040     p%= peek_w(nxt +8): q%= peek_w(nxt +10)
7050     m%= (w% *h% <=4096)                 : rem >010i; flag ptr size
7060     if m% then p%= abs(p%): q%= abs(q%) : rem >010i; allow for neg ofs ptr
7070     if p% <0 or p% >w% then r%= 0       : rem >010i; chk org limit
7080     if q% <0 or q% >h% then r%= 0
7090   end if
7100   if r% then
7110     if w% >xs% or h% >ys% then r%= -(r% +2) : rem >010i; <-2= oversized for AW
7120   end if
7130   if r% then adr= nxt: else adr= 0          : rem >010g; 0= invalid
7140   ret r%
7150  end def Next_Valid
7160  ::
7170  def proc Dyna_off
7180  rem >010e N: >010g; always off
7190   sprs #er%, 0: sprd%= 0: beep 20, 2
7200  end def
7210  ::
7220  def proc ChkPtr (f%)
7230  rem >>>010i; change ptr spr for dmd4%, f%= inf%
7240   if not f% then
7250     if smd8% or shw% =2 or shw% =-4 then sprs #er%, spm8: ret
7260     if smdh% or abs(shw%) >63 then sprs #er%, hddr: ret
7270   end if
7280   sprs #er%, 0
7290  end def
7300  ::
7310  def proc ShowMode8 (adr, sv%)
7320  rem >>>010h N: show m8 if in m4, formal sv 1= show+save, -1= show, 0= skip
7330  loc t%, m%, tm% : tm%= sv%
7340   if not (dmd4% or tm%) then ret                       : rem >H>010i; dmode
7350   t%= peek(adr): m%= peek(adr +1)                      : rem >>> must be m4
7360   if t% =1 and m% =1 then
7370     mwindow #er%, -3: cls #mch: rdpt #er%, 48, -10, 10 : rem >>> move ptr
7380     mode 8: ShowSpr adr, 0                             : rem >>> show mode 8
7390     sel on tm%
7400       =1  : SavPic 0: tm%= 50                          : rem >010i; save 2 pic
7410       =-1 : tm%= 400                                   : rem >010i; show
7420     end sel
7430     rdpt #er%, 1, -10, 10, tm%                         : rem >>> max 8s
7440     mode 4: mdraw #er%                                 : rem >>> restore
7450   end if
7460  end def
7470  ::
7480  def proc IniTimer (d%)
7490  rem >>>010b N: set initial timer Globals ;>010f;
7500   dn%= 0: if d% then dn%= peek(cspr +2)
7510  end def IniTimer
7520  ::
7530  def fn TrimDir$ (f$)
7540  rem >>>009b N: get spr.name ;>010c; msd
7550  loc e%, dc, s%, t%
7560   e%= len(f$) -4                             : rem >>> assume '_spr'/'.spr' ext
7570   for s% =e% to 1 step -1
7580     if f$(s%) ='_' then
7590       dc= fop_in(f$( to s%))                 : rem >>> chk for dir
7600       if dc <0 then next s%                  : rem >>> can't open part name
7610       t%= ftyp(#dc)
7620       if t% <>255 and t% <>4351 then next s% : rem >>> not QL or Msd dir
7630       s%= s% +1: exit s%                     : rem >>> must be dir
7640     end if
7650   end for s%
7660   close #dc: ret f$(s% TO e%)
7670  end def TrimDir$
7680  ::
7690  def proc Save2pic (adr)
7700  rem >>>009a N: copy from scr to pic;
7710  loc k$, k%
7720  rem >>> Isolate sprite
7730   inf%= 0: ShowSpr cspr, 0                     : rem >010f; off if info
7740   mwindow #er%, -3: Erm er%, 675: over #mch; 0 : rem >010a; erm
7750   rem:: print #mch; 'adr: ' &adr: pause #mch   : rem >T>010i;
7760
7770   k%= mstat%(#er%, -3)                         : rem Get current status
7780   sel on k%
7790     =-1 : wm_paper #mch; sp_litemunabg%
7800     = 0 : wm_paper #mch; sp_litemavabg%
7810     = 1 : wm_paper #mch; sp_litemselbg%
7820   end sel
7830   rem:: cls #mch: pause #mch: return
7840  :
7850   wm_ink #mch; sp_litemavafg%                  : rem >010c; =521
7860   print #mch; beta$ !datm$
7870   print #mch; 'Save as Pic? (y/n)'
7880   k$= inkey$(#mch; 250): k%= (k$ =='y')        : rem >010b; confirm, 5s
7890   if dmd4% and (smd8% or shw% =2) then
7900     ShowMode8 cspr, k%                         : rem >010i; sav if k%
7910   else
7920     ShowSpr cspr, k%                           : rem >010h; restore/save spr
7930   end if
7940  end def Sav2pic
7950  ::
7960  def proc SavPic (pr%)
7970  rem >>>010i N: actual save [save2] >pr 0= m8, no print
7980  loc s2adr, svx%, svy%, sxo%, syo%, stmp$
7990   stmp$= 'ram2_Sprv2pic_pic'
8000   s2adr= wsain(#er%, svx%, svy%)                  : rem >>> reserve mem
8010   mwindow #er%, -3: over #mch; 0
8020   Erm er%, 0: if er% <>mch then er%= mch: ret     : rem >>> 0= not fatal
8030  :
8040   rem >>> get coords of sprt
8050   svx% = peek_w(cspr +4) +4: svy% = peek_w(cspr +6) +4 : rem >010h;
8060   sxo%= 2 +(xs% -svx%) div 2                   : rem >>> 2px margin all sides
8070   syo%= 2 +(ys% -svy%) div 2
8080   wsasv #er%, s2adr, svx%, svy%, sxo%, syo%, 0, 0 : rem >>> scr/spr to buff
8090   if pr% then print #mch; '> ' &svx% &'x' &svy%
8100   delete stmp$: s_wsa s2adr, stmp$                : rem >>> save buff
8110   if pr% then print #mch; '> ' &stmp$
8120   if s2adr then rechp s2adr                       : rem >>> ret mem
8130  end def
8140  ::
8150 :rem:-end-of-sbasic
